//------------------------------------------------------------------ 
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window 
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    T3Price      = PRICE_CLOSE;
extern bool   T3Original   = false;
extern double T3Hot        = 0.4;
extern double T3MainPeriod = 11;
extern double T3Period1    =  5;
extern double T3Period2    = 10;
extern double T3Period3    = 15;
extern double T3Period4    = 20;
extern double T3Period5    = 25;
extern double T3Period6    = 30;
extern double T3Period7    = 40;

//
//
//
//
//

double tshuu[];
double tshud[];
double tshdd[];
double tshdu[];
double ts[];
double slope[];
double periods[];
int    total;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void addPeriod(int period)
{
   if (period>0)
   {
      total = ArraySize(periods)+1;
              ArrayResize(periods,total);
                          periods[total-1] = period;
   }
}

//
//
//
//
//

int init() 
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,tshuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tshud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tshdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tshdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,ts);
   SetIndexBuffer(5,slope);
   
      //
      //
      //
      //
      //
      
      addPeriod(T3Period1); 
      addPeriod(T3Period2); 
      addPeriod(T3Period3); 
      addPeriod(T3Period4); 
      addPeriod(T3Period5); 
      addPeriod(T3Period6); 
      addPeriod(T3Period7); 
   
      string name = "";
         for (int i=0; i<total; i++)
         {  
            if (name!="")
                name = name+",";
                name = name+DoubleToStr(periods[i],1);
         }         
      IndicatorShortName("T3 trend strength ("+name+")"); 
   return(0); 
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
            
   for (int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,T3Price,i);
      double first = iT3(price,T3MainPeriod,T3Hot,T3Original,i,0);
      double sum   = 0;
         for (int k=0; k<total; k++) sum += (first-iT3(price,periods[k],T3Hot,T3Original,i,k+1));
                                     
         tshuu[i] = EMPTY_VALUE;         
         tshud[i] = EMPTY_VALUE;         
         tshdd[i] = EMPTY_VALUE;         
         tshdu[i] = EMPTY_VALUE;         
         ts[i]    = sum/total;
         slope[i] = slope[i+1];
            if (ts[i] > ts[i+1]) slope[i] =  1;
            if (ts[i] < ts[i+1]) slope[i] = -1;
            if (ts[i]>0)
               if (slope[i]==1)
                     tshuu[i] = ts[i];
               else  tshud[i] = ts[i];
            if (ts[i]<0)
               if (slope[i]==1)
                     tshdu[i] = ts[i];
               else  tshdd[i] = ts[i];
   } 
   return(0); 
} 


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][48];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}